diff --git a/include/Makefile.am b/include/Makefile.am
index 617aa4a6e67a..addf4bc92261 100644
--- a/include/Makefile.am
+++ b/include/Makefile.am
@@ -9,12 +9,20 @@ odpapiinclude_HEADERS = \
 	odp/api/barrier.h \
 	odp/api/buffer.h \
 	odp/api/byteorder.h \
+	odp/api/chksum.h \
+	odp/api/compiler.h \
 	odp/api/cpumask.h \
+	odp/api/deprecated.h \
+	odp/api/errno.h \
 	odp/api/event.h \
+	odp/api/feature.h \
+	odp/api/hash.h \
+	odp/api/hints.h \
 	odp/api/init.h \
 	odp/api/ipsec.h \
 	odp/api/pool.h \
 	odp/api/queue.h \
+	odp/api/random.h \
 	odp/api/rwlock.h \
 	odp/api/rwlock_recursive.h \
 	odp/api/schedule.h \
@@ -24,7 +32,9 @@ odpapiinclude_HEADERS = \
 	odp/api/spinlock_recursive.h \
 	odp/api/std_clib.h \
 	odp/api/std_types.h \
+	odp/api/support.h \
 	odp/api/sync.h \
+	odp/api/system_info.h \
 	odp/api/thread.h \
 	odp/api/thrmask.h \
 	odp/api/ticketlock.h \
diff --git a/platform/linux-generic/include/odp/api/chksum.h b/include/odp/api/chksum.h
similarity index 72%
rename from platform/linux-generic/include/odp/api/chksum.h
rename to include/odp/api/chksum.h
index 18dcb6d11cb9..6dd1554ce48d 100644
--- a/platform/linux-generic/include/odp/api/chksum.h
+++ b/include/odp/api/chksum.h
@@ -10,21 +10,13 @@
  * ODP checksum functions
  */
 
-#ifndef ODP_PLAT_CHKSUM_H_
-#define ODP_PLAT_CHKSUM_H_
+#ifndef ODP_API_CHKSUM_H_
+#define ODP_API_CHKSUM_H_
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-/** @ingroup odp_chksum
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/spec/chksum.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/api/compiler.h b/include/odp/api/compiler.h
similarity index 69%
rename from platform/linux-generic/include/odp/api/compiler.h
rename to include/odp/api/compiler.h
index 5249d5d6264b..04e815bb0fa5 100644
--- a/platform/linux-generic/include/odp/api/compiler.h
+++ b/include/odp/api/compiler.h
@@ -10,21 +10,13 @@
  * Compiler related
  */
 
-#ifndef ODP_PLAT_COMPILER_H_
-#define ODP_PLAT_COMPILER_H_
+#ifndef ODP_API_COMPILER_H_
+#define ODP_API_COMPILER_H_
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-/** @ingroup odp_compiler_optim
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/spec/compiler.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/api/deprecated.h b/include/odp/api/deprecated.h
similarity index 82%
rename from platform/linux-generic/include/odp/api/deprecated.h
rename to include/odp/api/deprecated.h
index 82797ebc4505..881f23d1975f 100644
--- a/platform/linux-generic/include/odp/api/deprecated.h
+++ b/include/odp/api/deprecated.h
@@ -10,8 +10,8 @@
  * Control deprecated API definitions
  */
 
-#ifndef ODP_PLAT_DEPRECATED_H_
-#define ODP_PLAT_DEPRECATED_H_
+#ifndef ODP_API_DEPRECATED_H_
+#define ODP_API_DEPRECATED_H_
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/platform/linux-generic/include/odp/api/errno.h b/include/odp/api/errno.h
similarity index 83%
rename from platform/linux-generic/include/odp/api/errno.h
rename to include/odp/api/errno.h
index f70d84df0112..420d5d078339 100644
--- a/platform/linux-generic/include/odp/api/errno.h
+++ b/include/odp/api/errno.h
@@ -10,14 +10,13 @@
  * ODP errno API
  */
 
-#ifndef ODP_PLAT_ERRNO_H_
-#define ODP_PLAT_ERRNO_H_
+#ifndef ODP_API_ERRNO_H_
+#define ODP_API_ERRNO_H_
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-
 #include <odp/api/spec/errno.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/api/feature.h b/include/odp/api/feature.h
similarity index 71%
rename from platform/linux-generic/include/odp/api/feature.h
rename to include/odp/api/feature.h
index 55a86a831084..6bbde3c3831a 100644
--- a/platform/linux-generic/include/odp/api/feature.h
+++ b/include/odp/api/feature.h
@@ -10,21 +10,13 @@
  * ODP features.
  */
 
-#ifndef ODP_PLAT_FEATURE_H_
-#define ODP_PLAT_FEATURE_H_
+#ifndef ODP_API_FEATURE_H_
+#define ODP_API_FEATURE_H_
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-/** @ingroup odp_feature
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/spec/feature.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/api/hash.h b/include/odp/api/hash.h
similarity index 72%
rename from platform/linux-generic/include/odp/api/hash.h
rename to include/odp/api/hash.h
index 332029ed0a24..8e1699ccce67 100644
--- a/platform/linux-generic/include/odp/api/hash.h
+++ b/include/odp/api/hash.h
@@ -10,21 +10,13 @@
  * ODP Hash function
  */
 
-#ifndef ODP_PLAT_HASH_H_
-#define ODP_PLAT_HASH_H_
+#ifndef ODP_API_HASH_H_
+#define ODP_API_HASH_H_
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-/** @ingroup odp_hash
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/spec/hash.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/api/hints.h b/include/odp/api/hints.h
similarity index 70%
rename from platform/linux-generic/include/odp/api/hints.h
rename to include/odp/api/hints.h
index 3ba1ba95ed4f..c4d134b74818 100644
--- a/platform/linux-generic/include/odp/api/hints.h
+++ b/include/odp/api/hints.h
@@ -10,21 +10,13 @@
  * ODP compiler hints
  */
 
-#ifndef ODP_PLAT_HINTS_H_
-#define ODP_PLAT_HINTS_H_
+#ifndef ODP_API_HINTS_H_
+#define ODP_API_HINTS_H_
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-/** @ingroup odp_compiler_optim
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/spec/hints.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/api/random.h b/include/odp/api/random.h
similarity index 70%
rename from platform/linux-generic/include/odp/api/random.h
rename to include/odp/api/random.h
index c8529b3f9b9a..4ce973840cd7 100644
--- a/platform/linux-generic/include/odp/api/random.h
+++ b/include/odp/api/random.h
@@ -10,21 +10,13 @@
  * ODP random number API
  */
 
-#ifndef ODP_PLAT_RANDOM_H_
-#define ODP_PLAT_RANDOM_H_
+#ifndef ODP_API_RANDOM_H_
+#define ODP_API_RANDOM_H_
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-/** @ingroup odp_random ODP RANDOM
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/spec/random.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/api/support.h b/include/odp/api/support.h
similarity index 73%
rename from platform/linux-generic/include/odp/api/support.h
rename to include/odp/api/support.h
index dd6abab23a29..6c1759d4b8f6 100644
--- a/platform/linux-generic/include/odp/api/support.h
+++ b/include/odp/api/support.h
@@ -10,21 +10,13 @@
  * ODP support API - platform specific header
  */
 
-#ifndef ODP_PLAT_SUPPORT_H_
-#define ODP_PLAT_SUPPORT_H_
+#ifndef ODP_API_SUPPORT_H_
+#define ODP_API_SUPPORT_H_
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-/** @ingroup odp_support
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/spec/support.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/api/system_info.h b/include/odp/api/system_info.h
similarity index 82%
rename from platform/linux-generic/include/odp/api/system_info.h
rename to include/odp/api/system_info.h
index 36ddc814b4c0..7b95a876affa 100644
--- a/platform/linux-generic/include/odp/api/system_info.h
+++ b/include/odp/api/system_info.h
@@ -10,8 +10,8 @@
  * ODP system information
  */
 
-#ifndef ODP_PLAT_SYSTEM_INFO_H_
-#define ODP_PLAT_SYSTEM_INFO_H_
+#ifndef ODP_API_SYSTEM_INFO_H_
+#define ODP_API_SYSTEM_INFO_H_
 
 #ifdef __cplusplus
 extern "C" {
@@ -19,7 +19,6 @@ extern "C" {
 
 #include <odp/api/std_types.h>
 
-
 #include <odp/api/spec/system_info.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index 3aee7ce6340e..14b449ea42c1 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -20,24 +20,14 @@ odpinclude_HEADERS = \
 odpapiincludedir= $(includedir)/odp/api
 odpapiinclude_HEADERS = \
 		  include/odp/api/align.h \
-		  include/odp/api/chksum.h \
 		  include/odp/api/classification.h \
-		  include/odp/api/compiler.h \
 		  include/odp/api/cpu.h \
 		  include/odp/api/crypto.h \
 		  include/odp/api/debug.h \
-		  include/odp/api/deprecated.h \
-		  include/odp/api/errno.h \
-		  include/odp/api/feature.h \
-		  include/odp/api/hash.h \
-		  include/odp/api/hints.h \
 		  include/odp/api/packet_flags.h \
 		  include/odp/api/packet.h \
 		  include/odp/api/packet_io.h \
-		  include/odp/api/packet_io_stats.h \
-		  include/odp/api/random.h \
-		  include/odp/api/support.h \
-		  include/odp/api/system_info.h
+		  include/odp/api/packet_io_stats.h
 
 odpapiplatincludedir= $(includedir)/odp/api/plat
 odpapiplatinclude_HEADERS = \