diff --git a/include/Makefile.am b/include/Makefile.am
index 4436c61b2..b7c31c1f7 100644
--- a/include/Makefile.am
+++ b/include/Makefile.am
@@ -72,7 +72,8 @@ subsystemspecincludedir= $(includedir)/subsystem/spec
 subsystemspecinclude_HEADERS = \
 		  subsystem/spec/buffer_subsystem.h \
 		  subsystem/spec/pool_subsystem.h \
-		  subsystem/spec/queue_subsystem.h
+		  subsystem/spec/queue_subsystem.h \
+		  subsystem/spec/schedule_subsystem.h
 
 odpapiabidefaultincludedir= $(includedir)/odp/arch/default/api/abi
 odpapiabidefaultinclude_HEADERS = \
diff --git a/platform/linux-generic/include/odp_schedule_subsystem.h b/include/subsystem/spec/schedule_subsystem.h
similarity index 100%
rename from platform/linux-generic/include/odp_schedule_subsystem.h
rename to include/subsystem/spec/schedule_subsystem.h
diff --git a/platform/linux-dpdk/Makefile.am b/platform/linux-dpdk/Makefile.am
index 7742aea3e..6dde37b9c 100644
--- a/platform/linux-dpdk/Makefile.am
+++ b/platform/linux-dpdk/Makefile.am
@@ -214,7 +214,6 @@ noinst_HEADERS = \
 		  ${top_srcdir}/platform/linux-generic/include/odp_queue_if.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_ring_internal.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_schedule_if.h \
-		  ${top_srcdir}/platform/linux-generic/include/odp_schedule_subsystem.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_sorted_list_internal.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_shm_internal.h \
 		  ${top_srcdir}/platform/linux-generic/include/odp_time_internal.h \
diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index 47de83f92..8813aea92 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -199,7 +199,6 @@ noinst_HEADERS = \
 		  include/odp_schedule_scalable.h \
 		  include/odp_schedule_scalable_config.h \
 		  include/odp_schedule_scalable_ordered.h \
-		  include/odp_schedule_subsystem.h \
 		  include/odp_sorted_list_internal.h \
 		  include/odp_shm_internal.h \
 		  include/odp_time_internal.h \
diff --git a/platform/linux-generic/schedule/generic.c b/platform/linux-generic/schedule/generic.c
index 73fef40cb..e22762856 100644
--- a/platform/linux-generic/schedule/generic.c
+++ b/platform/linux-generic/schedule/generic.c
@@ -25,7 +25,7 @@
 #include <odp/api/packet_io.h>
 #include <odp_ring_internal.h>
 #include <odp_timer_internal.h>
-#include <odp_schedule_subsystem.h>
+#include <subsystem/spec/schedule_subsystem.h>
 #include <odp_packet_io_internal.h>
 
 /* Should remove this dependency */
diff --git a/platform/linux-generic/schedule/iquery.c b/platform/linux-generic/schedule/iquery.c
index 5de229832..76d96ff59 100644
--- a/platform/linux-generic/schedule/iquery.c
+++ b/platform/linux-generic/schedule/iquery.c
@@ -25,7 +25,7 @@
 #include <odp/api/packet_io.h>
 #include <odp_config_internal.h>
 #include <odp_timer_internal.h>
-#include <odp_schedule_subsystem.h>
+#include <subsystem/spec/schedule_subsystem.h>
 #include <odp_packet_io_internal.h>
 
 /* Should remove this dependency */
diff --git a/platform/linux-generic/schedule/scalable.c b/platform/linux-generic/schedule/scalable.c
index d8f538202..de9c65285 100644
--- a/platform/linux-generic/schedule/scalable.c
+++ b/platform/linux-generic/schedule/scalable.c
@@ -29,7 +29,7 @@
 #include <odp_llqueue.h>
 #include <odp_queue_scalable_internal.h>
 #include <odp_schedule_if.h>
-#include <odp_schedule_subsystem.h>
+#include <subsystem/spec/schedule_subsystem.h>
 #include <odp_bitset.h>
 #include <odp_packet_io_internal.h>
 
diff --git a/platform/linux-generic/schedule/sp.c b/platform/linux-generic/schedule/sp.c
index ea7b83422..06e2a1441 100644
--- a/platform/linux-generic/schedule/sp.c
+++ b/platform/linux-generic/schedule/sp.c
@@ -18,7 +18,7 @@
 #include <odp_config_internal.h>
 #include <odp_ring_internal.h>
 #include <odp_timer_internal.h>
-#include <odp_schedule_subsystem.h>
+#include <subsystem/spec/schedule_subsystem.h>
 #include <odp_packet_io_internal.h>
 #include <odp_queue_internal.h>
 
diff --git a/platform/linux-generic/schedule/subsystem.c b/platform/linux-generic/schedule/subsystem.c
index ba9a095f4..516cdf3b1 100644
--- a/platform/linux-generic/schedule/subsystem.c
+++ b/platform/linux-generic/schedule/subsystem.c
@@ -15,7 +15,7 @@
 #include <odp_debug_internal.h>
 #include <odp_internal.h>
 #include <odp_module.h>
-#include <odp_schedule_subsystem.h>
+#include <subsystem/spec/schedule_subsystem.h>
 
 ODP_SUBSYSTEM_DEFINE(schedule, "schedule public APIs",
 		     SCHEDULE_SUBSYSTEM_VERSION);